USE mysql;

REPLACE INTO user (host, user, password)
    VALUES (
        'localhost',
        'exim',
-- IMPORTANT: Change this password!
        PASSWORD('exim')
);

REPLACE INTO db (host, db, user, select_priv, insert_priv, update_priv,
                 delete_priv, create_priv, drop_priv, index_priv, Execute_priv)
    VALUES (
        'localhost',
        'exim',
        'exim',
        'Y', 'Y', 'Y', 'Y',
        'Y', 'Y', 'Y', 'Y'
);

FLUSH PRIVILEGES;

CREATE DATABASE `exim`;
USE exim;

CREATE TABLE `account` (
  `accountname` varchar(255) NOT NULL default '',
  `passwd` varchar(255) default NULL,
  `accountType` enum('MBOX','FORWARD','PIPE') NOT NULL default 'MBOX',
  `dataHam` text NOT NULL,
  `dataSpam` text,
  `filters` text,
  `hasAutoresponder` enum('t','f') NOT NULL default 'f',
  `autoresponderSubject` varchar(255) default NULL,
  `autoresponderText` text,
  `finaldest` varchar(255) NOT NULL default '',
  `finaldestSpam` varchar(255) default NULL,
  `virtual` enum('t','f') NOT NULL default 'f',
  `uid` int(11) NOT NULL default '0',
  `spamScanType` set('INACTIVE','SPAMFOLDER','MARK','SUBJECT') NOT NULL default 'SPAMFOLDER',
  `virusScanType` set('INACTIVE','SPAMFOLDER','REJECT','SUBJECT') NOT NULL default 'REJECT',
  `useSPF` enum('t','f') NOT NULL default 't',
  `useGreylist` enum('t','f') NOT NULL default 't',
  `useDomainKey` enum('t','f') NOT NULL default 't',
  `isAdmin` enum('t','d','f') NOT NULL default 'f',
  `toActivate` enum('t','f') NOT NULL default 't',
  `toDelete` enum('t','f') NOT NULL default 'f',
  `canModifyAlias` enum('t','f') NOT NULL default 't',
  `canSetAutoresponder` enum('t','f') NOT NULL default 't',
  `canUseFilters` enum('t','f') NOT NULL default 'f',
  `rejectedSpamScore` int(4) NOT NULL default '0',
  `rejectAfterSize` int(4) default NULL,
  PRIMARY KEY  (`accountname`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

CREATE TABLE IF NOT EXISTS `domain` (
  `domainname` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`domainname`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

CREATE TABLE IF NOT EXISTS `aliases` (
  `accountname` varchar(255) NOT NULL default '',
  `domainname` varchar(255) NOT NULL default '',
  `aliasname` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`accountname`, `domainname`, `aliasname`),
  FOREIGN KEY (`accountname`) REFERENCES account(accountname) ON DELETE CASCADE,
  FOREIGN KEY (`domainname`) REFERENCES domain(domainname) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

CREATE TABLE IF NOT EXISTS `userpref` (
  `prefid` int(11) NOT NULL auto_increment,
  `accountname` varchar(250) NOT NULL default '',
  `preference` varchar(250) NOT NULL default '',
  `value` text NOT NULL,
  PRIMARY KEY  (`prefid`),
  KEY `accountname` (`accountname`,`preference`),
  FOREIGN KEY (`accountname`) REFERENCES account(accountname) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

CREATE TABLE IF NOT EXISTS `awl` (
  `username` varchar(100) NOT NULL default '',
  `email` varchar(200) NOT NULL default '',
  `ip` varchar(50) NOT NULL default '',
  `count` int(11) default '0',
  `totscore` float default '0',
  PRIMARY KEY  (`username`,`email`,`ip`),
  FOREIGN KEY (`username`) REFERENCES account(accountname) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

CREATE TABLE IF NOT EXISTS `bayes_expire` (
  `id` int(11) NOT NULL default '0',
  `runtime` int(11) NOT NULL default '0',
  KEY `bayes_expire_idx1` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

CREATE TABLE IF NOT EXISTS `bayes_global_vars` (
  `variable` varchar(30) NOT NULL default '',
  `value` varchar(200) NOT NULL default '',
  PRIMARY KEY  (`variable`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

CREATE TABLE IF NOT EXISTS `bayes_seen` (
  `id` int(11) NOT NULL default '0',
  `msgid` varchar(200) binary NOT NULL default '',
  `flag` char(1) NOT NULL default '',
  PRIMARY KEY  (`id`,`msgid`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

CREATE TABLE IF NOT EXISTS `bayes_token` (
  `id` int(11) NOT NULL default '0',
  `token` char(5) NOT NULL default '',
  `spam_count` int(11) NOT NULL default '0',
  `ham_count` int(11) NOT NULL default '0',
  `atime` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`,`token`),
  KEY `bayes_token_idx1` (`token`),
  KEY `bayes_token_idx2` (`id`,`atime`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

CREATE TABLE IF NOT EXISTS `bayes_vars` (
  `id` int(11) NOT NULL auto_increment,
  `username` varchar(200) NOT NULL default '',
  `spam_count` int(11) NOT NULL default '0',
  `ham_count` int(11) NOT NULL default '0',
  `token_count` int(11) NOT NULL default '0',
  `last_expire` int(11) NOT NULL default '0',
  `last_atime_delta` int(11) NOT NULL default '0',
  `last_expire_reduce` int(11) NOT NULL default '0',
  `oldest_token_age` int(11) NOT NULL default '2147483647',
  `newest_token_age` int(11) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `bayes_vars_idx1` (`username`),
  FOREIGN KEY (`username`) REFERENCES account(accountname) ON DELETE CASCADE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

INSERT INTO bayes_global_vars VALUES ('VERSION','3');

CREATE TABLE `block_conns` (
  `IP` varchar(50) NOT NULL default '',
  `timestamp` timestamp NOT NULL default CURRENT_TIMESTAMP,
  `counter` tinyint(4) NOT NULL default '0',
  `block` enum('t','f') NOT NULL default 'f',
  PRIMARY KEY  (`IP`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

delimiter //
DROP FUNCTION IF EXISTS getPasswordForUser;
CREATE FUNCTION getPasswordForUser(login VARCHAR(255), lip VARCHAR(50), rip VARCHAR(50)) RETURNS VARCHAR(255) READS SQL DATA
BEGIN
  DECLARE pwd VARCHAR(255);
  DECLARE toBlock INTEGER;

  SELECT COUNT(*) INTO toBlock FROM block_conns WHERE IP = rip AND block = 't';
  IF toBlock = 1 THEN
    SET pwd = '<NONE>';
  ELSE
    SELECT passwd INTO pwd FROM account WHERE accountname = replace(replace(login, '.spam', ''), '.sent', '') AND virtual = 'f';
    IF pwd IS NULL THEN
      SET pwd = '<NONE>';
      IF rip != '127.0.0.1' AND lip != rip THEN
        INSERT INTO block_conns (IP, counter) VALUES(rip, 1) ON DUPLICATE KEY UPDATE counter = counter + 1, timestamp = NOW(), block = if(counter>=5, 't', 'f');
      END IF;
    END IF;
  END IF;

  RETURN pwd;
END//

DROP FUNCTION IF EXISTS isIPBlocked;
CREATE FUNCTION isIPBlocked(rip VARCHAR(50)) RETURNS VARCHAR(1) READS SQL DATA
BEGIN
  DECLARE toBlock INTEGER;

  SELECT COUNT(*) INTO toBlock FROM block_conns WHERE IP = rip AND block = 't';
  IF toBlock = 1 THEN
    RETURN 'Y';
  END IF;

  RETURN 'N';
END//
