#!/usr/bin/perl

################################################################################
#    Config 1.0. Configuration Server for an Exim Mailsystem                   #
#    Using DB Framwork for PHP  1.1.                                           #
#    Copyright (C) 2006 Luca Bertoncello                                       #
#    Hartigstrasse, 12 - 01127 Dresden Deutschland                             #
#    E-Mail: lucabert@lucabert.de, lucabert@lucabert.com                       #
#    http://www.lucabert.de/  http://www.lucabert.com/                         #
#                                                                              #
#    This program is free software; you can redistribute it and/or modify      #
#    it under the terms of the GNU General Public License as published by      #
#    the Free Software Foundation; version 2 of the License.                   #
#                                                                              #
#    This program is distributed in the hope that it will be useful,           #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#    GNU General Public License for more details.                              #
#                                                                              #
#    You should have received a copy of the GNU General Public License         #
#    along with this program; if not, write to the Free Software               #
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA #
################################################################################

use Mail::POP3Client;
use Date::Manip;
use DBI;

if($ARGV[0] eq '')
{
  print "Usage:\ndelOldSpamEMails.pl <path to node_config.php>\n";
  exit(-1);
}
open(CFG, $ARGV[0]);
@cfgs = <CFG>;
close(CFG);
$dbHost = getConfigVar("['DATABASE']['SERVER']", @cfgs);
$dbUser = getConfigVar("['DATABASE']['USER']", @cfgs);
$dbPass = getConfigVar("['DATABASE']['PASSWORD']", @cfgs);
$dataBase = getConfigVar("['DATABASE']['DATABASE']", @cfgs);

($mailDB = DBI->connect("DBI:mysql:dbname=$dataBase;host=$dbHost", $dbUser, $dbPass)) or die DBI::errstr;

($m,$m,$m,$dH,$mH,$yH) = localtime(time);
$yH += 1900;
$mH++;
($m,$m,$m,$dD,$mD,$yD) = localtime(time - (86400 * 14));
$yD += 1900;
$mD++;
$unixD = Date_SecsSince1970($mD, $dD, $yD, 0, 0, 0);

printf("%02d.%02d.%4d  - Starting check old Spam (delete all Spam before %02d.%02d.%4d)\n", $dH, $mH, $yH, $dD, $mD, $yD);
$sth = $mailDB->prepare("SELECT accountname, passwd FROM account WHERE accountType = 'MBOX' ORDER BY accountname");
($sth->execute()) or die "ERROR: Query failed.\n";
while((@values = $sth->fetchrow()))
{
  $accountname = $values[0];
  $passwd = $values[1];

  $pop = new Mail::POP3Client( HOST  => 'localhost', DEBUG => 0, AUTH_MODE => 'PASS', TIMEOUT => 60 );
  $pop->User("$accountname.spam");
  $pop->Pass($passwd);
  $pop->Connect();

  $nDeletedSpam = 0;
  $tot = $pop->Count();
  for($msg = 1; $msg <= $tot; $msg++)
  {
    @header = $pop->Head($msg);
    for($l = 0; $l <= $#header; $l++)
    {
      $header[$l] =~ /^([^\ ]*) *([^\n]*)/;
      $tok = $1;
      $value = $2;
      $tok = uc($tok);

      if($tok =~ 'DATE:')
      {
        $date = $value;
      }
    }
    $d = ParseDate($date);
    $year = substr($d, 0, 4);
    $mon = substr($d, 4, 2);
    $day = substr($d, 6, 2);
    $unix = Date_SecsSince1970($mon, $day, $year, 0, 0, 0);
    if($unix < $unixD)
    {
      $pop->Delete($msg);
      $nDeletedSpam++;
    }
  }
  $pop->Close();
  if($nDeletedSpam != 0)
  {
    print "Delete $nDeletedSpam E-Mail old Spam from $accountname\n";
  }
}
print "End check old Spam\n";

$sth->finish();
$mailDB->disconnect();

sub getConfigVar
{
  my($varName, @cfgs) = @_;

  $varName =~ s/\[/\\\[/g;
  $varName =~ s/\]/\\\]/g;
  $varName =~ s/\'/\\\'/g;
  @fs = grep(/$varName/, @cfgs);
  $v = $fs[$#fs];
  $v =~ s/[\n\r]//g;
  ($x, $var) = split(/=/, $v);
  $var =~ s/\ //g;
  $var =~ s/\;//g;
  $var =~ s/\'//g;

  return($var);
}
