<?php
class Errors
{
  /**
   * Display an error on the browser 
   * 
   * @param Exception $exception
   */   
  public static function sysError($exception)
  {
    global $config;

    $session = myMVC_HttpSession::getInstance();

// Wenn der "Zurück"-Knopf des Browsers geklickt wird, hat das Framework mal Probleme.
// Mit diesem Abschnitt wird immer die aktuelle Action nochmal aufgerufen.
    if(strpos($exception->getMessage(), 'called but no action declared it') !== false)
    {
      $curAction = $session->getFromNamespace('controller', 'currentAction');
      $url = myMVC_HttpResponse::createURL(myMVC_HttpRequest::$TYPE_ACTION, $curAction);
      header("LOCATION: ".$url);
      exit();
    }

    myMVC_Logger::doLog(__METHOD__, __LINE__, $exception->getMessage()."\n".$exception->getTraceAsString(), ALERT_WARNING, false);
    myMVC_ErrorHandler::sendAlert($exception->getMessage()."\n".$exception->getTraceAsString());
    if($config['DISPLAY_SYSERROR'])
    {
      myMVC_Logger::doLog(__METHOD__, __LINE__, 'sysError: redirected to '.PAGE_ERROR, ALERT_WARNING, false);
      $sessId = '';
      if($config['SESSION_USECOOKIES'] == 0)
        $sessId = '?'.$session->getSessionId();
      if(headers_sent())
        print "<META http-equiv=\"refresh\" content=\"0;url=".PAGE_ERROR."$sessId\">";
      else
        header('Location:'.PAGE_ERROR.$sessId);
    }
    exit;
  }
}
?>
