<?php
/**
 * Logoutfunktion
 * 
 * Autor: Luca Bertoncello <lucabert@lucabert.de>
 */
class LogoutAction extends myMVC_BaseLogoutAction
{
  /**
   * Returns the CSS class of this action
   *
   * @return string                     The CSS class
   */
  public static function getCSSClass()
  {
    return 'general';
  }
  
  public static function getActionGroup()
  {
    return 'login';
  }

  /**
   * Returns the string to be displayed in the menu to identify the current action.
   * Only necessary if isMenuAction() returns true
   *
   * @return string                 The menu item
   */
  public static function getActionMenuName()
  {
    return _("Logout");
  }
  
  /**
   * Gibt den Name des Bildes für dieses Menüpunkt zurücl
   *
   * @return string                 The menu item
   */
  public static function getActionMenuImage()
  {
    return '';
  }

  /**
   * Log out the user and empty the session
   */
  public function perform()
  {
    $this->session->destroy();
    $this->session->setInNamespace('main', 'loggedOut', true);
    $response = new myMVC_HttpResponse();
    $response->setNext('LoginAction');
    return $response;
  }
}
?>
