<?php
class ManageDomainView extends GUIView
{
  public function __construct($engine, $session)
  {
    parent::__construct($engine, $session);
    $this->setTemplate('manageDomain.tpl');
  }

  /**
   * Returns the token used to identify the current View
   * 
   * @return string                 The token
   */
  public static function getViewToken()
  {
    return 'manageDomain';
  }

  /**
   * Prepare to render the View
   * 
   * @return boolean                true if the page can be display, false otherwise
   */
  public function preRender()
  {
    parent::preRender();

    $user = self::getLoggedUser();
    $this->setVariable('user', $user);
    $this->session->useNamespace('manageDomain');
    $this->setObject('domains', $this->getParameterFromPreviousPage('domains'));
    if($this->getParameterFromPreviousPage('error') === true)
      $this->setAllSubmitFields();

    return true;
  }
}
?>
