<?php
class ManageFilterView extends GUIView
{
  public function __construct($engine, $session)
  {
    parent::__construct($engine, $session);
    $this->setTemplate('manageFilter.tpl');
  }

  /**
   * Returns the token used to identify the current View
   * 
   * @return string                 The token
   */
  public static function getViewToken()
  {
    return 'manageFilter';
  }

  /**
   * Prepare to render the View
   * 
   * @return boolean                true if the page can be display, false otherwise
   */
  public function preRender()
  {
    parent::preRender();

    $this->engine->registerModifier('parseFilter', array('ManageFilterView', 'parseFilter'));

    $user = self::getLoggedUser();
    $this->setVariable('user', $user);
    $this->session->useNamespace('manageFilter');
    $this->setVariable('edit', $this->session->get('edit'));
    $this->setObject('filters', $this->session->get('filters'));
    $this->setObject('filterTests', Account::$filtersTests);
    $this->setObject('filterConditions', Account::$filtersConditions);
    $this->setObject('filterActions', Account::$filtersActions);
    $this->setVariable('maxLine', $this->session->get('maxLine'));
    $this->setVariable('filterTest', $this->session->get('filterTest'));
    $this->setVariable('filterCondition', $this->session->get('filterCondition'));
    $this->setVariable('value', $this->session->get('value'));
    $this->setVariable('andOr', $this->session->get('andOr'));
    if($this->session->get('edit') !== NULL)
    {
      $this->setVariable('filterActionFinish', $this->getParameterFromPreviousPage('filterActionFinish'));
      $this->setVariable('filterAction', $this->getParameterFromPreviousPage('filterAction'));
      $this->setVariable('destination', $this->getParameterFromPreviousPage('destination'));
    }
    $this->setObject('adminUser', $this->getParameterFromPreviousPage('adminUser'));
    $this->setObject('account', $this->getParameterFromPreviousPage('account'));
    if($this->getParameterFromPreviousPage('error') === true)
      $this->setAllSubmitFields();

    return true;
  }

  /**
   * Parst die Filter
   *
   * @param string $filter              Der zu parsen Filter
   * @return string                     Der geparste Filter
   */
  public static function parseFilter($filter)
  {
    return Account::parseFilter($filter);
  }
}
?>
